Index: /trunk/action.php
===================================================================
--- /trunk/action.php	(revision 4324)
+++ /trunk/action.php	(revision 4325)
@@ -72,5 +72,5 @@
 
 $result = pwg_query($query);
-$element_info = mysql_fetch_assoc($result);
+$element_info = pwg_db_fetch_assoc($result);
 if ( empty($element_info) )
 {
@@ -94,5 +94,5 @@
   LIMIT 1
 ;';
-if ( mysql_num_rows(pwg_query($query))<1 )
+if ( pwg_db_num_rows(pwg_query($query))<1 )
 {
   do_error(401, 'Access denied');
Index: /trunk/admin/cat_list.php
===================================================================
--- /trunk/admin/cat_list.php	(revision 4324)
+++ /trunk/admin/cat_list.php	(revision 4325)
@@ -120,5 +120,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $categories[ $row['id'] ] = strtolower($row['name']);
Index: /trunk/admin/cat_modify.php
===================================================================
--- /trunk/admin/cat_modify.php	(revision 4324)
+++ /trunk/admin/cat_modify.php	(revision 4325)
@@ -194,5 +194,5 @@
   WHERE id = '.$_GET['cat_id'].'
 ;';
-$category = mysql_fetch_assoc( pwg_query( $query ) );
+$category = pwg_db_fetch_assoc( pwg_query( $query ) );
 // nullable fields
 foreach (array('comment','dir','site_id', 'id_uppercat') as $nullable)
@@ -211,5 +211,5 @@
   LIMIT 1';
 $result = pwg_query($query);
-$category['has_images'] = mysql_num_rows($result)>0 ? true : false;
+$category['has_images'] = pwg_db_num_rows($result)>0 ? true : false;
 
 // Navigation path
@@ -374,5 +374,5 @@
   WHERE id = '.$category['representative_picture_id'].'
 ;';
-    $row = mysql_fetch_assoc(pwg_query($query));
+    $row = pwg_db_fetch_assoc(pwg_query($query));
     $src = get_thumbnail_url($row);
     $url = get_root_url().'admin.php?page=picture_modify';
@@ -462,7 +462,7 @@
 
     $result = pwg_query($query);
-    if (mysql_num_rows($result) > 0)
+    if (pwg_db_num_rows($result) > 0)
     {
-      $element = mysql_fetch_assoc($result);
+      $element = pwg_db_fetch_assoc($result);
 
       $img_url  = '<a href="'.
@@ -512,5 +512,5 @@
   WHERE id = '.$_POST['group'].'
 ;';
-  list($group_name) = mysql_fetch_row(pwg_query($query));
+  list($group_name) = pwg_db_fetch_row(pwg_query($query));
   
   array_push(
Index: /trunk/admin/cat_perm.php
===================================================================
--- /trunk/admin/cat_perm.php	(revision 4324)
+++ /trunk/admin/cat_perm.php	(revision 4325)
@@ -46,5 +46,5 @@
   WHERE id = '.$_GET['cat'].'
 ;';
-  list($status) = mysql_fetch_row(pwg_query($query));
+  list($status) = pwg_db_fetch_row(pwg_query($query));
   
   if ('private' == $status)
@@ -63,5 +63,5 @@
 ;';
 
-  list($page['cat']) = mysql_fetch_row(pwg_query($query));
+  list($page['cat']) = pwg_db_fetch_row(pwg_query($query));
 }
 
@@ -111,5 +111,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($granteds[$row['cat_id']], $row['group_id']);
@@ -170,5 +170,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($granteds[$row['cat_id']], $row['user_id']);
@@ -275,5 +275,5 @@
 ';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     if (!isset($granted_groups[$row['group_id']]))
Index: /trunk/admin/comments.php
===================================================================
--- /trunk/admin/comments.php	(revision 4324)
+++ /trunk/admin/comments.php	(revision 4325)
@@ -146,5 +146,5 @@
 ;';
 $result = pwg_query($query);
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $thumb = get_thumbnail_url(
Index: /trunk/admin/configuration.php
===================================================================
--- /trunk/admin/configuration.php	(revision 4324)
+++ /trunk/admin/configuration.php	(revision 4325)
@@ -139,5 +139,5 @@
     //echo '<pre>'; print_r($_POST); echo '</pre>';
     $result = pwg_query('SELECT param FROM '.CONFIG_TABLE);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       if (isset($_POST[$row['param']]))
Index: /trunk/admin/element_set.php
===================================================================
--- /trunk/admin/element_set.php	(revision 4324)
+++ /trunk/admin/element_set.php	(revision 4325)
@@ -193,5 +193,5 @@
   $query = 'SELECT MAX(date_available) AS date
   FROM '.IMAGES_TABLE;
-  if ($row = mysql_fetch_assoc( pwg_query($query) ) )
+  if ($row = pwg_db_fetch_assoc( pwg_query($query) ) )
   {
     $query = 'SELECT id
Index: /trunk/admin/element_set_global.php
===================================================================
--- /trunk/admin/element_set_global.php	(revision 4324)
+++ /trunk/admin/element_set_global.php	(revision 4325)
@@ -246,5 +246,5 @@
     $result = pwg_query($query);
 
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $data = array();
@@ -338,5 +338,5 @@
     AND storage_category_id IS NULL
 ;';
-  list($counter) = mysql_fetch_row(pwg_query($query));
+  list($counter) = pwg_db_fetch_row(pwg_query($query));
 
   if ($counter > 0)
@@ -482,5 +482,5 @@
   // template thumbnail initialization
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $src = get_thumbnail_url($row);
Index: /trunk/admin/element_set_ranks.php
===================================================================
--- /trunk/admin/element_set_ranks.php	(revision 4324)
+++ /trunk/admin/element_set_ranks.php	(revision 4325)
@@ -116,5 +116,5 @@
   WHERE id = '.$page['category_id'].'
 ;';
-$category = mysql_fetch_assoc(pwg_query($query));
+$category = pwg_db_fetch_assoc(pwg_query($query));
 
 // Navigation path
@@ -151,5 +151,5 @@
 $current_rank = 1;
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $src = get_thumbnail_url($row);
Index: /trunk/admin/element_set_unit.php
===================================================================
--- /trunk/admin/element_set_unit.php	(revision 4324)
+++ /trunk/admin/element_set_unit.php	(revision 4325)
@@ -57,5 +57,5 @@
   $result = pwg_query($query);
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $data = array();
@@ -201,5 +201,5 @@
   $result = pwg_query($query);
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     // echo '<pre>'; print_r($row); echo '</pre>';
Index: /trunk/admin/group_list.php
===================================================================
--- /trunk/admin/group_list.php	(revision 4324)
+++ /trunk/admin/group_list.php	(revision 4325)
@@ -61,5 +61,5 @@
   WHERE id = '.$_GET['delete'].'
 ;';
-  list($groupname) = mysql_fetch_row(pwg_query($query));
+  list($groupname) = pwg_db_fetch_row(pwg_query($query));
   
   // destruction of the group
@@ -95,5 +95,5 @@
   WHERE name = \''.$_POST['groupname'].'\'
 ;';
-    list($count) = mysql_fetch_row(pwg_query($query));
+    list($count) = pwg_db_fetch_row(pwg_query($query));
     if ($count != 0)
     {
@@ -108,5 +108,5 @@
   (name)
   VALUES
-  (\''.mysql_real_escape_string($_POST['groupname']).'\')
+  (\''.pwg_db_real_escape_string($_POST['groupname']).'\')
 ;';
     pwg_query($query);
@@ -130,5 +130,5 @@
   WHERE id = '.$_GET['toggle_is_default'].'
 ;';
-  list($groupname, $is_default) = mysql_fetch_row(pwg_query($query));
+  list($groupname, $is_default) = pwg_db_fetch_row(pwg_query($query));
   
   // update of the group
@@ -176,5 +176,5 @@
 $toggle_is_default_url     = $admin_url.'group_list&amp;toggle_is_default=';
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $query = '
@@ -183,5 +183,5 @@
   WHERE group_id = '.$row['id'].'
 ;';
-  list($counter) = mysql_fetch_row(pwg_query($query));
+  list($counter) = pwg_db_fetch_row(pwg_query($query));
   
   $template->append(
Index: /trunk/admin/group_perm.php
===================================================================
--- /trunk/admin/group_perm.php	(revision 4324)
+++ /trunk/admin/group_perm.php	(revision 4325)
@@ -80,5 +80,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($private_uppercats, $row['id']);
@@ -97,5 +97,5 @@
   $result = pwg_query($query);
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($authorized_ids, $row['cat_id']);
@@ -158,5 +158,5 @@
 $result = pwg_query($query_true);
 $authorized_ids = array();
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   array_push($authorized_ids, $row['id']);
Index: /trunk/admin/history.php
===================================================================
--- /trunk/admin/history.php	(revision 4324)
+++ /trunk/admin/history.php	(revision 4325)
@@ -111,5 +111,5 @@
       '*',
       '%',
-      mysql_real_escape_string($_POST['filename'])
+      pwg_db_real_escape_string($_POST['filename'])
       );
   }
@@ -137,5 +137,5 @@
     pwg_query($query);
 
-    $search_id = mysql_insert_id();
+    $search_id = pwg_db_insert_id();
 
     redirect(
@@ -178,5 +178,5 @@
   WHERE id = '.$page['search_id'].'
 ;';
-  list($serialized_rules) = mysql_fetch_row(pwg_query($query));
+  list($serialized_rules) = pwg_db_fetch_row(pwg_query($query));
 
   $page['search'] = unserialize($serialized_rules);
@@ -199,5 +199,5 @@
     pwg_query($query);
 
-    $search_id = mysql_insert_id();
+    $search_id = pwg_db_insert_id();
 
     redirect(
@@ -258,5 +258,5 @@
 
     $username_of = array();
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $username_of[$row['id']] = stripslashes($row['username']);
@@ -306,5 +306,5 @@
 
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $label_of_image[ $row['id'] ] = $row['label'];
@@ -342,5 +342,5 @@
 
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $name_of_tag[ $row['id'] ] = $row['name'];
Index: /trunk/admin/include/c13y_internal.class.php
===================================================================
--- /trunk/admin/include/c13y_internal.class.php	(revision 4324)
+++ /trunk/admin/include/c13y_internal.class.php	(revision 4325)
@@ -43,6 +43,6 @@
     $check_list[] = array('type' => 'PHP', 'current' => phpversion(), 'required' => REQUIRED_PHP_VERSION);
 
-    list($mysql_version) = mysql_fetch_row(pwg_query('SELECT VERSION();'));
-    $check_list[] = array('type' => 'MySQL', 'current' => $mysql_version, 'required' => REQUIRED_MYSQL_VERSION);
+    $db_version = pwg_get_db_version();
+    $check_list[] = array('type' => 'MySQL', 'current' => $db_version, 'required' => REQUIRED_MYSQL_VERSION);
 
     foreach ($check_list as $elem)
@@ -127,5 +127,5 @@
 
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $status[$row['id']] = $row['status'];
Index: /trunk/admin/include/functions.php
===================================================================
--- /trunk/admin/include/functions.php	(revision 4324)
+++ /trunk/admin/include/functions.php	(revision 4325)
@@ -37,5 +37,5 @@
   $result = pwg_query($query);
   $category_ids = array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($category_ids, $row['id']);
@@ -78,5 +78,5 @@
   $result = pwg_query($query);
   $element_ids = array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($element_ids, $row['id']);
@@ -160,5 +160,5 @@
 ;';
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $file_path = $row['path'];
@@ -410,208 +410,4 @@
 
 /**
- * inserts multiple lines in a table
- *
- * @param string table_name
- * @param array dbfields
- * @param array inserts
- * @return void
- */
-function mass_inserts($table_name, $dbfields, $datas)
-{
-  if (count($datas) != 0)
-  {
-    $first = true;
-
-    $query = 'SHOW VARIABLES LIKE \'max_allowed_packet\'';
-    list(, $packet_size) = mysql_fetch_row(pwg_query($query));
-    $packet_size = $packet_size - 2000; // The last list of values MUST not exceed 2000 character*/
-    $query = '';
-
-    foreach ($datas as $insert)
-    {
-      if (strlen($query) >= $packet_size)
-      {
-        pwg_query($query);
-        $first = true;
-      }
-
-      if ($first)
-      {
-        $query = '
-INSERT INTO '.$table_name.'
-  ('.implode(',', $dbfields).')
-  VALUES';
-        $first = false;
-      }
-      else
-      {
-        $query .= '
-  , ';
-      }
-
-      $query .= '(';
-      foreach ($dbfields as $field_id => $dbfield)
-      {
-        if ($field_id > 0)
-        {
-          $query .= ',';
-        }
-
-        if (!isset($insert[$dbfield]) or $insert[$dbfield] === '')
-        {
-          $query .= 'NULL';
-        }
-        else
-        {
-          $query .= "'".$insert[$dbfield]."'";
-        }
-      }
-      $query .= ')';
-    }
-    pwg_query($query);
-  }
-}
-
-define('MASS_UPDATES_SKIP_EMPTY', 1);
-/**
- * updates multiple lines in a table
- *
- * @param string table_name
- * @param array dbfields
- * @param array datas
- * @param int flags - if MASS_UPDATES_SKIP_EMPTY - empty values do not overwrite existing ones
- * @return void
- */
-function mass_updates($tablename, $dbfields, $datas, $flags=0)
-{
-  if (count($datas) == 0)
-    return;
-  // depending on the MySQL version, we use the multi table update or N update queries
-  if (count($datas) < 10 or version_compare(mysql_get_server_info(), '4.0.4') < 0)
-  { // MySQL is prior to version 4.0.4, multi table update feature is not available
-    foreach ($datas as $data)
-    {
-      $query = '
-UPDATE '.$tablename.'
-  SET ';
-      $is_first = true;
-      foreach ($dbfields['update'] as $key)
-      {
-        $separator = $is_first ? '' : ",\n    ";
-
-        if (isset($data[$key]) and $data[$key] != '')
-        {
-          $query.= $separator.$key.' = \''.$data[$key].'\'';
-        }
-        else
-        {
-          if ($flags & MASS_UPDATES_SKIP_EMPTY )
-            continue; // next field
-          $query.= "$separator$key = NULL";
-        }
-        $is_first = false;
-      }
-      if (!$is_first)
-      {// only if one field at least updated
-        $query.= '
-  WHERE ';
-        $is_first = true;
-        foreach ($dbfields['primary'] as $key)
-        {
-          if (!$is_first)
-          {
-            $query.= ' AND ';
-          }
-          if ( isset($data[$key]) )
-          {
-            $query.= $key.' = \''.$data[$key].'\'';
-          }
-          else
-          {
-            $query.= $key.' IS NULL';
-          }
-          $is_first = false;
-        }
-        pwg_query($query);
-      }
-    } // foreach update
-  } // if mysql_ver or count<X
-  else
-  {
-    // creation of the temporary table
-    $query = '
-SHOW FULL COLUMNS FROM '.$tablename;
-    $result = pwg_query($query);
-    $columns = array();
-    $all_fields = array_merge($dbfields['primary'], $dbfields['update']);
-    while ($row = mysql_fetch_assoc($result))
-    {
-      if (in_array($row['Field'], $all_fields))
-      {
-        $column = $row['Field'];
-        $column.= ' '.$row['Type'];
-
-        $nullable = true;
-        if (!isset($row['Null']) or $row['Null'] == '' or $row['Null']=='NO')
-        {
-          $column.= ' NOT NULL';
-          $nullable = false;
-        }
-        if (isset($row['Default']))
-        {
-          $column.= " default '".$row['Default']."'";
-        }
-        elseif ($nullable)
-        {
-          $column.= " default NULL";
-        }
-        if (isset($row['Collation']) and $row['Collation'] != 'NULL')
-        {
-          $column.= " collate '".$row['Collation']."'";
-        }
-        array_push($columns, $column);
-      }
-    }
-
-    $temporary_tablename = $tablename.'_'.micro_seconds();
-
-    $query = '
-CREATE TABLE '.$temporary_tablename.'
-(
-  '.implode(",\n  ", $columns).',
-  UNIQUE KEY the_key ('.implode(',', $dbfields['primary']).')
-)';
-
-    pwg_query($query);
-    mass_inserts($temporary_tablename, $all_fields, $datas);
-    if ( $flags & MASS_UPDATES_SKIP_EMPTY )
-      $func_set = create_function('$s', 'return "t1.$s = IFNULL(t2.$s, t1.$s)";');
-    else
-      $func_set = create_function('$s', 'return "t1.$s = t2.$s";');
-
-    // update of images table by joining with temporary table
-    $query = '
-UPDATE '.$tablename.' AS t1, '.$temporary_tablename.' AS t2
-  SET '.
-      implode(
-        "\n    , ",
-        array_map($func_set,$dbfields['update'])
-        ).'
-  WHERE '.
-      implode(
-        "\n    AND ",
-        array_map(
-          create_function('$s', 'return "t1.$s = t2.$s";'),
-          $dbfields['primary']
-          )
-        );
-    pwg_query($query);
-    $query = '
-DROP TABLE '.$temporary_tablename;
-    pwg_query($query);
-  }
-}
-
-/**
  * order categories (update categories.rank and global_rank database fields)
  * so that rank field are consecutive integers starting at 1 for each child
@@ -631,5 +427,5 @@
 
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     if ($row['id_uppercat'] != $current_uppercat)
@@ -777,5 +573,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $uppercats = array_merge($uppercats,
@@ -804,5 +600,5 @@
   LIMIT 0,1
 ;';
-    list($representative) = mysql_fetch_row(pwg_query($query));
+    list($representative) = pwg_db_fetch_row(pwg_query($query));
 
     array_push(
@@ -864,5 +660,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($categories, $row);
@@ -1140,5 +936,5 @@
   $datas = array();
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push(
@@ -1207,5 +1003,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $categories[$row['id']] =
@@ -1226,5 +1022,5 @@
   WHERE id = '.$new_parent.'
 ;';
-    list($new_parent_uppercats) = mysql_fetch_row(pwg_query($query));
+    list($new_parent_uppercats) = pwg_db_fetch_row(pwg_query($query));
 
     foreach ($categories as $category)
@@ -1271,5 +1067,5 @@
   WHERE id = '.$new_parent.'
 ;';
-    list($parent_status) = mysql_fetch_row(pwg_query($query));
+    list($parent_status) = pwg_db_fetch_row(pwg_query($query));
   }
 
@@ -1356,5 +1152,5 @@
   WHERE id_uppercat '.(is_numeric($parent_id) ? '= '.$parent_id : 'IS NULL').'
 ;';
-  list($current_rank) = mysql_fetch_row(pwg_query($query));
+  list($current_rank) = pwg_db_fetch_row(pwg_query($query));
 
   $insert = array(
@@ -1372,5 +1168,5 @@
   WHERE id = '.$parent_id.'
 ;';
-    $parent = mysql_fetch_assoc(pwg_query($query));
+    $parent = pwg_db_fetch_assoc(pwg_query($query));
 
     $insert['id_uppercat'] = $parent['id'];
@@ -1418,5 +1214,5 @@
     );
 
-  $inserted_id = mysql_insert_id();
+  $inserted_id = pwg_db_insert_id();
 
   $query = '
@@ -1551,5 +1347,5 @@
       );
 
-    $page['tag_id_from_tag_name_cache'][$tag_name] = mysql_insert_id();
+    $page['tag_id_from_tag_name_cache'][$tag_name] = pwg_db_insert_id();
   }
   else
@@ -1593,68 +1389,4 @@
       $inserts
       );
-  }
-}
-
-/**
- * Do maintenance on all PWG tables
- *
- * @return none
- */
-function do_maintenance_all_tables()
-{
-  global $prefixeTable, $page;
-
-  $all_tables = array();
-
-  // List all tables
-  $query = 'SHOW TABLES LIKE \''.$prefixeTable.'%\'';
-  $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
-  {
-    array_push($all_tables, $row[0]);
-  }
-
-  // Repair all tables
-  $query = 'REPAIR TABLE '.implode(', ', $all_tables);
-  $mysql_rc = pwg_query($query);
-
-  // Re-Order all tables
-  foreach ($all_tables as $table_name)
-  {
-    $all_primary_key = array();
-
-    $query = 'DESC '.$table_name.';';
-    $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
-    {
-      if ($row['Key'] == 'PRI')
-      {
-        array_push($all_primary_key, $row['Field']);
-      }
-    }
-
-    if (count($all_primary_key) != 0)
-    {
-      $query = 'ALTER TABLE '.$table_name.' ORDER BY '.implode(', ', $all_primary_key).';';
-      $mysql_rc = $mysql_rc && pwg_query($query);
-    }
-  }
-
-  // Optimize all tables
-  $query = 'OPTIMIZE TABLE '.implode(', ', $all_tables);
-  $mysql_rc = $mysql_rc && pwg_query($query);
-  if ($mysql_rc)
-  {
-    array_push(
-          $page['infos'],
-          l10n('Optimizations completed')
-          );
-  }
-  else
-  {
-    array_push(
-          $page['errors'],
-          l10n('Optimizations errors')
-          );
   }
 }
@@ -1890,5 +1622,5 @@
       );
 
-    $inserted_id = mysql_insert_id();
+    $inserted_id = pwg_db_insert_id();
 
     return array(
@@ -2076,7 +1808,7 @@
 ;';
   $result = pwg_query($query);
-  if (mysql_num_rows($result) > 0)
-  {
-    list($groupname) = mysql_fetch_row($result);
+  if (pwg_db_num_rows($result) > 0)
+  {
+    list($groupname) = pwg_db_fetch_row($result);
   }
   else
@@ -2104,7 +1836,7 @@
 ;';
   $result = pwg_query($query);
-  if (mysql_num_rows($result) > 0)
-  {
-    list($username) = mysql_fetch_row($result);
+  if (pwg_db_num_rows($result) > 0)
+  {
+    list($username) = pwg_db_fetch_row($result);
   }
   else
Index: /trunk/admin/include/functions_history.inc.php
===================================================================
--- /trunk/admin/include/functions_history.inc.php	(revision 4324)
+++ /trunk/admin/include/functions_history.inc.php	(revision 4325)
@@ -166,5 +166,5 @@
   $result = pwg_query($query);
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($data, $row);
Index: /trunk/admin/include/functions_metadata.php
===================================================================
--- /trunk/admin/include/functions_metadata.php	(revision 4324)
+++ /trunk/admin/include/functions_metadata.php	(revision 4325)
@@ -260,5 +260,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($cat_ids, $row['id']);
@@ -285,5 +285,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $files[$row['id']] = $row['path'];
Index: /trunk/admin/include/functions_notification_by_mail.inc.php
===================================================================
--- /trunk/admin/include/functions_notification_by_mail.inc.php	(revision 4324)
+++ /trunk/admin/include/functions_notification_by_mail.inc.php	(revision 4325)
@@ -60,5 +60,5 @@
   check_key = \''.$key.'\';';
 
-    list($count) = mysql_fetch_row(pwg_query($query));
+    list($count) = pwg_db_fetch_row(pwg_query($query));
     if ($count == 0)
     {
@@ -168,5 +168,5 @@
     if (!empty($result))
     {
-      while ($nbm_user = mysql_fetch_assoc($result))
+      while ($nbm_user = pwg_db_fetch_assoc($result))
       {
         array_push($data_users, $nbm_user);
Index: /trunk/admin/include/functions_permalinks.php
===================================================================
--- /trunk/admin/include/functions_permalinks.php	(revision 4324)
+++ /trunk/admin/include/functions_permalinks.php	(revision 4325)
@@ -52,6 +52,6 @@
   $result = pwg_query($query);
   $cat_id = null;
-  if ( mysql_num_rows($result) )
-    list( $cat_id ) = mysql_fetch_row($result);
+  if ( pwg_db_num_rows($result) )
+    list( $cat_id ) = pwg_db_fetch_row($result);
   return $cat_id;
 }
@@ -73,7 +73,7 @@
 ;';
   $result = pwg_query($query);
-  if ( mysql_num_rows($result) )
-  {
-    list($permalink) = mysql_fetch_row($result);
+  if ( pwg_db_num_rows($result) )
+  {
+    list($permalink) = pwg_db_fetch_row($result);
   }
   if ( !isset($permalink) )
Index: /trunk/admin/include/functions_upgrade.php
===================================================================
--- /trunk/admin/include/functions_upgrade.php	(revision 4324)
+++ /trunk/admin/include/functions_upgrade.php	(revision 4325)
@@ -113,5 +113,5 @@
   $result = pwg_query($query);
   $plugins = array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($plugins, $row['id']);
@@ -139,5 +139,5 @@
   if(!@get_magic_quotes_gpc())
   {
-    $username = mysql_real_escape_string($username);
+    $username = pwg_db_real_escape_string($username);
   }
 
@@ -166,5 +166,5 @@
 ;';
   }
-  $row = mysql_fetch_assoc(pwg_query($query));
+  $row = pwg_db_fetch_assoc(pwg_query($query));
 
   if (!isset($conf['pass_convert']))
Index: /trunk/admin/intro.php
===================================================================
--- /trunk/admin/intro.php	(revision 4324)
+++ /trunk/admin/intro.php	(revision 4325)
@@ -54,7 +54,7 @@
     // if the current version is a BSF (development branch) build, we check
     // the first line, for stable versions, we check the second line
-    if (preg_match('/^BSF/', $versions{'current'}))
-    {
-      $versions{'latest'} = trim($lines[0]);
+    if (preg_match('/^BSF/', $versions['current']))
+    {
+      $versions['latest'] = trim($lines[0]);
 
       // because integer are limited to 4,294,967,296 we need to split BSF
@@ -62,5 +62,5 @@
       foreach ($versions as $key => $value)
       {
-        $versions{$key} =
+        $versions[$key] =
           preg_replace('/BSF_(\d{8})(\d{4})/', '$1.$2', $value);
       }
@@ -68,8 +68,8 @@
     else
     {
-      $versions{'latest'} = trim($lines[1]);
-    }
-
-    if ('' == $versions{'latest'})
+      $versions['latest'] = trim($lines[1]);
+    }
+
+    if ('' == $versions['latest'])
     {
       array_push(
@@ -80,5 +80,5 @@
     // concatenation needed to avoid automatic transformation by release
     // script generator
-    else if ('%'.'PWGVERSION'.'%' == $versions{'current'})
+    else if ('%'.'PWGVERSION'.'%' == $versions['current'])
     {
       array_push(
@@ -87,5 +87,5 @@
         );
     }
-    else if (version_compare($versions{'current'}, $versions{'latest'}) < 0)
+    else if (version_compare($versions['current'], $versions['latest']) < 0)
     {
       array_push(
@@ -126,5 +126,6 @@
 
 $php_current_timestamp = date("Y-m-d H:i:s");
-list($mysql_version, $db_current_timestamp) = mysql_fetch_row(pwg_query('SELECT VERSION(), CURRENT_TIMESTAMP;'));
+$db_version = pwg_get_db_version();
+list($db_current_timestamp) = pwg_db_fetch_row(pwg_query('SELECT CURRENT_TIMESTAMP;'));
 
 $query = '
@@ -132,5 +133,5 @@
   FROM '.IMAGES_TABLE.'
 ;';
-list($nb_elements) = mysql_fetch_row(pwg_query($query));
+list($nb_elements) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -138,5 +139,5 @@
   FROM '.CATEGORIES_TABLE.'
 ;';
-list($nb_categories) = mysql_fetch_row(pwg_query($query));
+list($nb_categories) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -145,5 +146,5 @@
   WHERE dir IS NULL
 ;';
-list($nb_virtual) = mysql_fetch_row(pwg_query($query));
+list($nb_virtual) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -152,5 +153,5 @@
   WHERE dir IS NOT NULL
 ;';
-list($nb_physical) = mysql_fetch_row(pwg_query($query));
+list($nb_physical) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -158,5 +159,5 @@
   FROM '.IMAGE_CATEGORY_TABLE.'
 ;';
-list($nb_image_category) = mysql_fetch_row(pwg_query($query));
+list($nb_image_category) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -164,5 +165,5 @@
   FROM '.TAGS_TABLE.'
 ;';
-list($nb_tags) = mysql_fetch_row(pwg_query($query));
+list($nb_tags) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -170,5 +171,5 @@
   FROM '.IMAGE_TAG_TABLE.'
 ;';
-list($nb_image_tag) = mysql_fetch_row(pwg_query($query));
+list($nb_image_tag) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -176,5 +177,5 @@
   FROM '.USERS_TABLE.'
 ;';
-list($nb_users) = mysql_fetch_row(pwg_query($query));
+list($nb_users) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -182,5 +183,5 @@
   FROM '.GROUPS_TABLE.'
 ;';
-list($nb_groups) = mysql_fetch_row(pwg_query($query));
+list($nb_groups) = pwg_db_fetch_row(pwg_query($query));
 
 $query = '
@@ -188,5 +189,5 @@
   FROM '.COMMENTS_TABLE.'
 ;';
-list($nb_comments) = mysql_fetch_row(pwg_query($query));
+list($nb_comments) = pwg_db_fetch_row(pwg_query($query));
 
 $template->assign(
@@ -196,5 +197,6 @@
     'OS' => PHP_OS,
     'PHP_VERSION' => phpversion(),
-    'MYSQL_VERSION' => $mysql_version,
+    'DB_ENGINE' => 'MySQL',
+    'DB_VERSION' => $db_version,
     'DB_ELEMENTS' => l10n_dec('%d element', '%d elements', $nb_elements),
     'DB_CATEGORIES' =>
@@ -224,5 +226,5 @@
   FROM '.IMAGES_TABLE.'
 ;';
-  list($first_date) = mysql_fetch_row(pwg_query($query));
+  list($first_date) = pwg_db_fetch_row(pwg_query($query));
 
   $template->assign(
@@ -244,5 +246,5 @@
   WHERE validated=\'false\'
 ;';
-list($nb_waiting) = mysql_fetch_row(pwg_query($query));
+list($nb_waiting) = pwg_db_fetch_row(pwg_query($query));
 
 if ($nb_waiting > 0)
@@ -263,5 +265,5 @@
   WHERE validated=\'false\'
 ;';
-list($nb_comments) = mysql_fetch_row(pwg_query($query));
+list($nb_comments) = pwg_db_fetch_row(pwg_query($query));
 
 if ($nb_comments > 0)
Index: /trunk/admin/notification_by_mail.php
===================================================================
--- /trunk/admin/notification_by_mail.php	(revision 4324)
+++ /trunk/admin/notification_by_mail.php	(revision 4325)
@@ -146,10 +146,10 @@
   $result = pwg_query($query);
 
-  if (mysql_num_rows($result) > 0)
+  if (pwg_db_num_rows($result) > 0)
   {
     $inserts = array();
     $check_key_list = array();
 
-    while ($nbm_user = mysql_fetch_assoc($result))
+    while ($nbm_user = pwg_db_fetch_assoc($result))
     {
       // Calculate key
@@ -239,5 +239,5 @@
   if (in_array($action, array('list_to_send', 'send')))
   {
-    list($dbnow) = mysql_fetch_row(pwg_query('SELECT NOW();'));
+    list($dbnow) = pwg_db_fetch_row(pwg_query('SELECT NOW();'));
 
     $is_action_send = ($action == 'send');
@@ -513,5 +513,5 @@
       // Update param
       $result = pwg_query('select param, value from '.CONFIG_TABLE.' where param like \'nbm\\_%\'');
-      while ($nbm_user = mysql_fetch_assoc($result))
+      while ($nbm_user = pwg_db_fetch_assoc($result))
       {
         if (isset($_POST[$nbm_user['param']]))
